package net.krakatoa.proxy.command;

import de.dytanic.cloudnet.driver.CloudNetDriver;
import de.dytanic.cloudnet.driver.permission.IPermissionUser;
import earth.krakatao.debug.DebugMessage;
import net.krakatoa.proxy.ProxySystem;
import net.md_5.bungee.api.CommandSender;
import net.md_5.bungee.api.chat.TextComponent;
import net.md_5.bungee.api.connection.ProxiedPlayer;
import net.md_5.bungee.api.plugin.Command;
import org.redisson.api.RMap;

public class KrakatoapCommand extends Command {

  public KrakatoapCommand(String name) {
    super(name);
  }

  @Override
  public void execute(CommandSender sender, String[] args) {
    if (sender instanceof ProxiedPlayer) {
      ProxiedPlayer player = (ProxiedPlayer) sender;

      IPermissionUser permissionUser = CloudNetDriver.getInstance().getPermissionManagement()
          .getUser(player.getUniqueId());

      if (permissionUser != null && permissionUser.hasPermission("*").asBoolean()) {
        player.sendMessage(new TextComponent(
            DebugMessage.GetMessage(CloudNetDriver.getInstance().getComponentName(),
                ProxySystem.getInstance().getKraSocketClient().getSocketClient()
                    .getDest(), ProxySystem.getInstance().getKraSocketClientProtocol()
                    .getSendQueueMessages().size(), ProxySystem.getInstance()
                    .getKraSocketClientProtocol()
                    .getReceivedQueueMessages().size())));

        String uuid = ProxySystem.getInstance().getFormatter().formatUuid(player.getUniqueId());

        RMap<String, String> map = ProxySystem.getInstance().getRedisManager()
            .getRedissonClient()
            .getMap("player:" + uuid);

        if (!map.isEmpty()) {
          player.sendMessage(new TextComponent("\n§cRedis player data:"));
          map.forEach((key, value) -> {
            player.sendMessage(new TextComponent("§7key: §e" + key + " §7value: §e" + value));
          });
        }
      }
    }
  }
}
