package net.krakatoa.proxy.listener;

import com.mongodb.client.model.Filters;
import java.io.IOException;
import java.security.SecureRandom;
import net.krakatoa.proxy.ProxySystem;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.HoverEvent;
import net.md_5.bungee.api.chat.HoverEvent.Action;
import net.md_5.bungee.api.chat.TextComponent;
import net.md_5.bungee.api.chat.hover.content.Text;
import net.md_5.bungee.api.connection.ProxiedPlayer;
import net.md_5.bungee.api.event.PostLoginEvent;
import net.md_5.bungee.api.event.ServerSwitchEvent;
import net.md_5.bungee.api.plugin.Listener;
import net.md_5.bungee.event.EventHandler;
import org.bson.Document;
import org.reactivestreams.Publisher;
import org.reactivestreams.Subscriber;
import org.reactivestreams.Subscription;

public class PostLoginListener implements Listener {

  @EventHandler
  public void onPostLogin(PostLoginEvent event) throws IOException {
    ProxiedPlayer proxiedPlayer = event.getPlayer();

    String uuid = ProxySystem.getInstance().getFormatter()
        .formatUuid(proxiedPlayer.getUniqueId().toString());

    Publisher<Document> document = ProxySystem.getInstance().getMongoManager()
        .getPlayersCollection()
        .find(Filters.eq("uuid", uuid)).first();

    ProxySystem.getInstance().getLogger().info("debug1");
    document.subscribe(new Subscriber<>() {
      @Override
      public void onSubscribe(Subscription subscription) {
        subscription.request(1);
        ProxySystem.getInstance().getLogger().info("Subscripe");
      }

      @Override
      public void onNext(Document document) {
        ProxySystem.getInstance().getLogger().info("Inserted");
        ProxySystem.getInstance().getLogger().info("Inserted: " + document);


      }

      @Override
      public void onError(Throwable throwable) {
        ProxySystem.getInstance().getLogger().info("Failed " + throwable);
      }

      @Override
      public void onComplete() {
        ProxySystem.getInstance().getLogger().info("Completed");
      }
    });

    ProxySystem.getInstance().getLogger().info("debug2 testa");



    /*
    if (document == null) { // new player - create entries in databases
      System.out.println("create player in db");
      String voiceWebCode = generateVoiceWebCode(uuid);

      document = new Document("uuid", uuid).append("voiceWebCode", voiceWebCode);

      ProxySystem.getInstance().getMongoManager().getPlayersCollection().insertOne(document);

      sendVoiceWebCodeUrl(proxiedPlayer, voiceWebCode);

      // redis

      RMap<String, String> map = ProxySystem.getInstance().getRedisManager()
          .getRedissonClient()
          .getMap("player:" + uuid);

      if (map.isEmpty()) {
        map.put("uuid", uuid);
        map.put("voiceWebCode", "voiceWebCode");

        ProxySystem.getInstance().getLogger().info("PUT !");
      } else {
        ProxySystem.getInstance().getLogger()
            .warning("REDIS player " + uuid + " exists in the cache, but should not exist");
      }
    } else { // player found in the database

      // redis
      ProxySystem.getInstance().getLogger().info("mongodb player " + document.keySet());

      RMap<String, String> map = ProxySystem.getInstance().getRedisManager()
          .getRedissonClient()
          .getMap("player:" + uuid);

      if (map.isEmpty()) {
        map.put("uuid", uuid);
        map.put("voiceWebCode", "voiceWebCode");

        document.forEach((key, value) -> {
          if (!Objects.equals(key, "_id")) {
            ProxySystem.getInstance().getLogger()
                .info("key " + key + " value " + value.toString());
            map.put(key, value.toString());
          }
        });
        ProxySystem.getInstance().getLogger().info("PUT !");
      } else {
        ProxySystem.getInstance().getLogger()
            .warning("REDIS player " + uuid + " exists in the cache, but should not exist");
      }

      // check if both sockets connected
      int cmdID = ProxySystem.getInstance().getKraSocketClientProtocol().generateCmdID();

      Document finalDocument = document;
      Consumer<KraSocketClientProtocolMessage> consumer = value -> {
        if (value.getArgs().equals("1")) {
          // connected! Send player to game server
          System.out.println(
              proxiedPlayer.getName() + " sockets connected! Send player to game server");
          proxiedPlayer.sendMessage(
              new TextComponent("§bWillkommen zurück §6" + proxiedPlayer.getDisplayName()));

          ProxyServer.getInstance().getScheduler().schedule(ProxySystem.getInstance(), () -> {
            ServerInfo serverInfos = ProxyServer.getInstance().getServerInfo("NewYork-1");
            proxiedPlayer.connect(serverInfos);
          }, 2L, TimeUnit.SECONDS);
        } else {
          // not connected! Send voice url
          System.out.println(
              proxiedPlayer.getName() + " sockets not connected! Send voice url");

          String voiceWebCode = generateVoiceWebCode(uuid);

          Bson updates = Updates.combine(Updates.set("voiceWebCode", voiceWebCode));

          UpdateOptions options = new UpdateOptions().upsert(true);

          ProxySystem.getInstance().getMongoManager().getPlayersCollection()
              .updateOne(finalDocument, updates, options);

          System.out.println("voiceWebCode " + voiceWebCode);

          sendVoiceWebCodeUrl(proxiedPlayer, voiceWebCode);
        }

        System.out.println(
            "consumer response value " + value.getUuid() + " " + value.getCmdID());
      };

      ProxySystem.getInstance().getKraSocketClient().getSocketClient()
          .SendMessage(new KraSocketClientProtocolMessage(
              KraSocketClientProtocolStatus.GET.getStatus(), cmdID,
              KraSocketClientProtocolDest.BACKEND.getStatus(), proxiedPlayer.getUniqueId(),
              (short) 10, "", consumer));
    }


    /*
    MessageBufferPacker packer = MessagePack.newDefaultBufferPacker();

    packer.packString(proxiedPlayer.getName());
    packer.packInt(3501983);
    packer.packArrayHeader(2);
    packer.packString("number 1");
    packer.packString("number 2");

    packer.close(); */
/*
    RBucket<PlayerTest> bucket = ProxySystem.getInstance().getRedisManager().getRedissonClient()
        .getBucket("player:" + proxiedPlayer.getUniqueId().toString());

    ProxySystem.getInstance().getLogger().info("here1");

    if (bucket != null) {
      PlayerTest playerTest = bucket.get();

      ProxySystem.getInstance().getLogger().info("here2 " + (playerTest == null));

      if (playerTest == null) {
        playerTest = new PlayerTest(proxiedPlayer.getName(), 250, "scooter");

        ProxySystem.getInstance().getLogger()
            .info("my playertest " + playerTest.getName() + playerTest.getCar());

        bucket.set(playerTest);

        ProxySystem.getInstance().getLogger().info("created bucket for playerTest");
      } else {
        ProxySystem.getInstance().getLogger().info("playerTest " + playerTest);
      }
    }*/



    /*MessageUnpacker unpacker = MessagePack.newDefaultUnpacker(packer.toByteArray());

    String playerName = unpacker.unpackString();
    int n = unpacker.unpackInt();
    int nuArr = unpacker.unpackArrayHeader();
    String[] nu = new String[nuArr];
    for (int i = 0; i < nuArr; i++) {
      nu[i] = unpacker.unpackString();
    }

    unpacker.close(); */
/*
    ProxySystem.getInstance().getLogger()
        .info("name: " + playerName + " " + n + " " + nu[0] + " " + nu[1]); */
  }

  public void sendVoiceWebCodeUrl(ProxiedPlayer proxiedPlayer, String voiceWebCode) {
    String url = ProxySystem.getInstance().getConfigHandler()
        .getWebVoiceAddress() + voiceWebCode;

    TextComponent textComponent = new TextComponent(
        "Klicke auf den Link, um dich mit dem Voice Server zu verbinden");

    TextComponent linkComponent = new TextComponent(url);
    linkComponent.setHoverEvent(new HoverEvent(Action.SHOW_TEXT,
        new Text(url)));
    linkComponent.setClickEvent(
        new ClickEvent(ClickEvent.Action.OPEN_URL,
            url));

    textComponent.addExtra("\n");
    textComponent.addExtra(linkComponent);

    proxiedPlayer.sendMessage(textComponent);
  }

  public String generateVoiceWebCode(String uuid) {
    SecureRandom secureRandom = new SecureRandom();

    String chrs = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";

    String customTag = secureRandom.ints(8, 0, chrs.length()).mapToObj(chrs::charAt)
        .collect(StringBuilder::new, StringBuilder::append, StringBuilder::append).toString();

    System.out.println(customTag);


   /* String chrs = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
    SecureRandom secureRandom = SecureRandom.getInstanceStrong();

    String customTag = secureRandom.ints(9, 0, chrs.length()).mapToObj(chrs::charAt)
        .collect(StringBuilder::new, StringBuilder::append, StringBuilder::append).toString();
    System.out.println(customTag);

    /*AtomicBoolean avail = new AtomicBoolean(false);

    while (!avail.get()) {
      System.out.println("while");
      secureRandom.ints(8, 0, chrs.length()).mapToObj(chrs::charAt)
          .collect(StringBuilder::new, StringBuilder::append, StringBuilder::append).toString();
      System.out.println(customTag);

      ProxySystem.getInstance().getPlayerRegistrationProcess().find(Filters.eq("webCode", chrs))
          .first((document, throwable) -> {
            if (document == null) {
              avail.set(true);
            }
          });
    }*/

    return customTag;
  }

  @EventHandler
  public void onServerSwitch(ServerSwitchEvent event) {
    ProxiedPlayer player = event.getPlayer();

    player.sendMessage(
        new TextComponent("Switched server " + player.getServer().getInfo().getName()));
  }

  /*

  @EventHandler
  public void onServerConnect(ServerConnectEvent event) {
    System.out.println(
        "REASON " + event.getReason() + " " + event.getPlayer().getUniqueId().toString());

    if (!event.getReason().equals(Reason.JOIN_PROXY)) {
      System.out.println("return join proxy");
      return;
    }

  //  event.setTarget(ProxyServer.getInstance().getServerInfo("NewYork-1"));
/*
    ProxySystem.getInstance().getKraProtocol()
        .SendMessage(11, 10, 0, event.getPlayer().getUniqueId().toString().replaceAll("-", ""), 10,
            "");

    //event.setTarget(ProxyServer.getInstance().getServerInfo("NewYork-1"));
  } */
}
